"""Core utilities common to all other modules"""

# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/api/00_core.ipynb.

# %% auto 0
__all__ = ['pad', 'attrkey', 'str_enumerate', 'cz']

# %% ../nbs/api/00_core.ipynb 3
from fastcore.all import *

# %% ../nbs/api/00_core.ipynb 4
def pad(s: str, pad_to: int):
    "Pad `s` with spaces to the right"
    return s + " " * max(0, (pad_to - len(s)))

# %% ../nbs/api/00_core.ipynb 6
def attrkey(attr):
    "Create a function that fetches `attr` of its input"
    return lambda x: getattr(x, attr)

# %% ../nbs/api/00_core.ipynb 7
def str_enumerate(lst: list,
                  start: int = 0 # enumerate from what number
                 ) -> Iterable[str]:
    "Create aligned sequence of numbered strings for strings in `lst`"
    return map(lambda x: f"  {pad(str(x[0]),2)}  {x[1]}", enumerate(lst, start))

# %% ../nbs/api/00_core.ipynb 8
def cz(*funcs):
    "Compose functions together"
    def fn(x):
        for fn in funcs:
            x = fn(x)
        return x
    return fn
